#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>

#define MAX 205
#define INFTY 200000
#define EPS 0.000001
using namespace std;

typedef int I;
typedef vector<int> VI;

map<string, int> m;

long double pole[MAX][MAX];

int main(void)
{
	char st[5], froms[5], tos[5];
	string h;
	I n,i,j,k,e,from,to,a,b;

	scanf("%d\n", &n);
	while(n)
	{
		m.clear();

		for(i=0;i<n;i++)
		{
			scanf(" %s",st);
			h = st;
			m[h] = i;
		}

		for(i=0;i<n;i++)
		{
			for(j=0;j<n;j++)
			{
				pole[i][j] = INFTY;
			}
		}


		scanf("%d\n", &e);
		for(i=0;i<e;i++)
		{
			scanf("%s %s", froms, tos);
			string fS(froms);
			string tS(tos);
			from = m[fS];
			to = m[tS];

			scanf("%d:%d\n",&a,&b);
			long double p = b / (long double) a;
			//printf("translating %s %s as %d %d\n", froms,tos,from,to);
			//printf("p %llf and its log %llf\n", p, log(p));
			pole[from][to] = -1 * log(p);
	
		}
	/*
		for(i=0;i<n;i++)
		{
			for(j=0;j<n;j++)
			{
				printf("%d %d %llf\n", i, j, pole[i][j]);
			}
		}
*/
		for(k=0;k<n;k++)
		{
			for(i=0;i<n;i++)
			{
				for(j=0;j<n;j++)
				{
					if(pole[i][j] > pole[i][k] + pole[k][j])
					{
						pole[i][j] = pole[i][k] + pole[k][j];
					}
				}
			}
		}
/*
		printf("----\n");
		for(i=0;i<n;i++)
		{
			for(j=0;j<n;j++)
			{
				printf("%d %d %llf\n", i, j, pole[i][j]);
			}
		}

*/
		bool done = false;
		for(i=0;i<n;i++)
		{
			if(pole[i][i] < -EPS)
			{
				printf("Arbitrage\n");
				done=true;
				break;

			}
		}
		if(!done)
		{
			printf("Ok\n");
		}


		scanf("%d\n", &n);
	}
}
